/* if you're going to add new attributes, use numbers 1500 and up. that way
 * you won't have to go to renumbering pains when upgrading. make sure
 * you change max_atrnum in db.c. */


#define OSEE AF_OSEE
#define SDARK AF_DARK
#define WIZARD AF_WIZARD
#define UNIMP AF_UNIMP
#define NOMOD AF_NOMOD
#define DATE AF_DATE
#define INH AF_INHERIT
#define LOCK AF_LOCK
#define FUNC AF_FUNC
#define DBREF AF_DBREF
#define NOMEM AF_NOMEM
#define TIME AF_TIME

DOATTR(A_OSUCC,		  "Osucc",	     INH,			1)
DOATTR(A_OFAIL,		  "Ofail",	     INH,			2)
DOATTR(A_FAIL,		  "Fail",	     INH,			3)
DOATTR(A_SUCC,		  "Succ",	     INH,			4)
DOATTR(A_PASS,		  "Password",	     WIZARD|SDARK|NOMOD|NOMEM,	5)
DOATTR(A_DESC,		  "Desc",	     INH,			6)
DOATTR(A_SEX,		  "Sex",	     INH|OSEE,			7)
DOATTR(A_ODROP,		  "Odrop",	     INH,			8)
DOATTR(A_DROP,		  "Drop",	     INH,			9)
#ifdef USE_INCOMING
DOATTR(A_INCOMING,	  "Incoming",	     INH,			10)
#endif
DOATTR(A_LJOIN,		  "LJoin",	     INH|LOCK,			11)
DOATTR(A_ASUCC,		  "Asucc",	     INH,			12)
DOATTR(A_AFAIL,		  "Afail",	     INH,			13)
DOATTR(A_ADROP,		  "Adrop",	     INH,			14)
DOATTR(A_DOES,		  "Does",	     INH,			16)
DOATTR(A_CHARGES,	  "Charges",	     INH,			17)
DOATTR(A_RUNOUT,	  "Runout",	     INH,			18)
DOATTR(A_STARTUP,	  "Startup",	     INH|WIZARD,		19)
DOATTR(A_ACLONE,	  "Aclone",	     INH,			20)
DOATTR(A_APAY,		  "Apay",	     INH,			21)
DOATTR(A_OPAY,		  "Opay",	     INH,			22)
DOATTR(A_PAY,		  "Pay",	     INH,			23)
DOATTR(A_COST,		  "Cost",	     INH,			24)
DOATTR(A_LASTDISC,	  "Lastdisc",	     WIZARD|DATE|OSEE|NOMEM,	25)
DOATTR(A_LISTEN,	  "Listen",	     INH,			26)
DOATTR(A_AAHEAR,	  "Aahear",	     INH,			27)
DOATTR(A_AMHEAR,	  "Amhear",	     INH,			28)
DOATTR(A_AHEAR,		  "Ahear",	     INH,			29)
DOATTR(A_LASTCONN,	  "Lastconn",	     WIZARD|DATE|OSEE|NOMEM,	30)
DOATTR(A_QUEUE,		  "Queue",	     WIZARD|UNIMP|NOMEM,	31)
DOATTR(A_IDESC,		  "IDesc",	     INH,			32)
DOATTR(A_ENTER,		  "Enter",	     INH,			33)
DOATTR(A_OENTER,	  "Oenter",	     INH,			34)
DOATTR(A_AENTER,	  "Aenter",	     INH,			35)
DOATTR(A_ADESC,		  "Adesc",	     INH,			36)
DOATTR(A_ODESC,		  "Odesc",	     INH,			37)
DOATTR(A_RQUOTA,	  "Rquota",	     SDARK|NOMOD|WIZARD|NOMEM,	38)
DOATTR(A_IDLE,		  "Idle",	     INH,			39)
DOATTR(A_AWAY,		  "Away",	     INH,			40)
DOATTR(A_MAILK,		  "Mailk",	     SDARK|NOMOD|WIZARD|UNIMP|NOMEM,41)
DOATTR(A_ALIAS,		  "Alias",	     OSEE,			42)
DOATTR(A_EFAIL,		  "Efail",	     INH,			43)
DOATTR(A_OEFAIL,	  "Oefail",	     INH,			44)
DOATTR(A_AEFAIL,	  "Aefail",	     INH,			45)
DOATTR(A_IT,		  "It",		     UNIMP|DBREF|NOMEM,		46)
DOATTR(A_LEAVE,		  "Leave",	     INH,			47)
DOATTR(A_OLEAVE,	  "Oleave",	     INH,			48)
DOATTR(A_ALEAVE,	  "Aleave",	     INH,			49)
DOATTR(A_CHANNEL,	  "Channel",	     WIZARD,			50)
DOATTR(A_QUOTA,		  "Quota",	     SDARK|NOMOD|UNIMP|WIZARD|NOMEM,51)
DOATTR(A_PENNIES,	  "Pennies",	     WIZARD|SDARK|NOMOD|NOMEM,	52)
DOATTR(A_HUHTO,		  "Huhto",	     WIZARD,			53)
DOATTR(A_HAVEN,		  "Haven",	     INH,			54)
DOATTR(A_TZ,		  "TZ",		     INH,			57)
DOATTR(A_DOOMSDAY,	  "Doomsday",	     WIZARD,			58)
DOATTR(A_ATIME,           "ATime",           INH, 			59)

DOATTR(A_RACE,		  "Race",	     INH|WIZARD|OSEE,		99)
#ifndef DECLARE_ATTR
DOATTR(A_V[0],		  "Va",		     INH,			100+0)
DOATTR(A_V[1],		  "Vb",		     INH,			100+1)
DOATTR(A_V[2],		  "Vc",		     INH,			100+2)
DOATTR(A_V[3],		  "Vd",		     INH,			100+3)
DOATTR(A_V[4],		  "Ve",		     INH,			100+4)
DOATTR(A_V[5],		  "Vf",		     INH,			100+5)
DOATTR(A_V[6],		  "Vg",		     INH,			100+6)
DOATTR(A_V[7],		  "Vh",		     INH,			100+7)
DOATTR(A_V[8],		  "Vi",		     INH,			100+8)
DOATTR(A_V[9],		  "Vj",		     INH,			100+9)
DOATTR(A_V[10],		  "Vk",		     INH,			100+10)
DOATTR(A_V[11],		  "Vl",		     INH,			100+11)
DOATTR(A_V[12],		  "Vm",		     INH,			100+12)
DOATTR(A_V[13],		  "Vn",		     INH,			100+13)
DOATTR(A_V[14],		  "Vo",		     INH,			100+14)
DOATTR(A_V[15],		  "Vp",		     INH,			100+15)
DOATTR(A_V[16],		  "Vq",		     INH,			100+16)
DOATTR(A_V[17],		  "Vr",		     INH,			100+17)
DOATTR(A_V[18],		  "Vs",		     INH,			100+18)
DOATTR(A_V[19],		  "Vt",		     INH,			100+19)
DOATTR(A_V[20],		  "Vu",		     INH,			100+20)
DOATTR(A_V[21],		  "Vv",		     INH,			100+21)
DOATTR(A_V[22],		  "Vw",		     INH,			100+22)
DOATTR(A_V[23],		  "Vx",		     INH,			100+23)
DOATTR(A_V[24],		  "Vy",		     INH,			100+24)
DOATTR(A_V[25],		  "Vz",		     INH,			100+25)
#else /* declare_attr */
DOATTR(A_V[26],		  "v attributes",    -1,			   -1);
#endif /* declare_attr */
DOATTR(A_MOVE,		  "Move",	     INH,			126)
DOATTR(A_OMOVE,		  "Omove",	     INH,			127)
DOATTR(A_AMOVE,		  "Amove",	     INH,			128)
DOATTR(A_LOCK,		  "Lock",	     INH|LOCK,			129)
DOATTR(A_ELOCK,		  "LEnter",	     INH|LOCK,			130)
DOATTR(A_ULOCK,		  "LUse",	     INH|LOCK,			131)
DOATTR(A_UFAIL,		  "Ufail",	     INH,			132)
DOATTR(A_OUFAIL,	  "Oufail",	     INH,			133)
DOATTR(A_AUFAIL,	  "Aufail",	     INH,			134)
DOATTR(A_OCONN,		  "Oconnect",	     INH,			135)
DOATTR(A_ACONN,		  "Aconnect",	     INH,			136)
DOATTR(A_ODISC,		  "Odisconnect",     INH,			137)
DOATTR(A_ADISC,		  "Adisconnect",     INH,			138)
DOATTR(A_COLUMNS,	  "Columns",	     INH,			139)
DOATTR(A_WHOFLAGS,	  "Who_Flags",	     INH,			140)
DOATTR(A_WHONAMES,	  "Who_Names",	     INH,			141)
DOATTR(A_APAGE,		  "Apage",	     INH,			142)
DOATTR(A_APEMIT,	  "Apemit",	     INH,			143)
DOATTR(A_AWHISPER,	  "Awhisper",	     INH,			144)
DOATTR(A_NICE,		  "Nice",	     INH,			145)


DOATTR(A_USE,		  "Use",	     INH,			155)
DOATTR(A_OUSE,		  "OUse",	     INH,			156)
DOATTR(A_AUSE,		  "AUse",	     INH,			157)
DOATTR(A_LHIDE,		  "LHide",	     INH|LOCK,			158)
DOATTR(A_LPAGE,		  "LPage",	     INH|LOCK,			159)
DOATTR(A_LLOCK,		  "LLeave",	     INH|LOCK,			161)
DOATTR(A_LFAIL,		  "Lfail",	     INH,			162)
DOATTR(A_OLFAIL,	  "Olfail",	     INH,			163)
DOATTR(A_ALFAIL,	  "Alfail",	     INH,			164)
DOATTR(A_SLOCK,		  "Slock",	     INH|LOCK,			165)
DOATTR(A_SFAIL,		  "Sfail",	     INH,			166)
DOATTR(A_OSFAIL,	  "Osfail",	     INH,			167)
DOATTR(A_ASFAIL,	  "Asfail",	     INH,			168)
DOATTR(A_DOING,		  "Doing",	     INH|OSEE,			169)
DOATTR(A_USERS,		  "Users",	     INH|WIZARD|DBREF,		170)
DOATTR(A_DEFOWN,	  "Defown",	     INH|DBREF,			171)
DOATTR(A_WARNINGS,	  "Warnings",	     INH,			172)
DOATTR(A_WINHIBIT,	  "WInhibit",	     INH,			173)
DOATTR(A_ANEWS,		  "ANews",	     INH,			174)
DOATTR(A_AIDESC,	  "AIDesc",	     INH,			175)
DOATTR(A_OIDESC,	  "OIDesc",	     INH,			176)
DOATTR(A_BYTESUSED,	  "Bytesused",	     UNIMP|WIZARD|NOMOD|NOMEM,	177)
DOATTR(A_BYTELIMIT,	  "Bytelimit",	     WIZARD|NOMEM,		178)
DOATTR(A_HTIN,		  "HtIn",	     INH,			179)
DOATTR(A_RLPAGE,	  "RLpage",	     INH,			180)
DOATTR(A_LRLPAGE, 	  "LRLpage",	     INH|LOCK,			181)
DOATTR(A_RLPAGELEN,	  "RLpageLen",	     INH,			182)
DOATTR(A_RLPAGESSF,	  "RLpageSSF",	     INH|LOCK,			183)
DOATTR(A_BLACKLIST,       "Blacklist",       INH|LOCK,                  192)
DOATTR(A_AIDLE,           "AIdle",           INH,			195)
DOATTR(A_AUNIDLE,         "AUnidle",         INH,			196)
DOATTR(A_ATPORT,          "ATport",          INH,			200)
DOATTR(A_AFTPORT,         "AFTport",         INH,			201)
DOATTR(A_TPORT,           "Tport",           INH,			202)
DOATTR(A_OTPORT,          "OTport",          INH,			203)

DOATTR(A_LOCATION,	  "Location",	     AF_BUILTIN|DBREF,		256)
DOATTR(A_LINK,		  "Link",	     AF_BUILTIN|DBREF,		257)
DOATTR(A_CONTENTS,	  "Contents",	     AF_BUILTIN|DBREF,		258)
DOATTR(A_EXITS,		  "Exits",	     AF_BUILTIN|DBREF,		259)
DOATTR(A_CHILDREN,	  "Children",	     AF_BUILTIN|DBREF,		260)
DOATTR(A_PARENTS,	  "Parents",	     AF_BUILTIN|DBREF,		261)
DOATTR(A_OWNER,		  "Owner",	     AF_BUILTIN|DBREF,		262)
DOATTR(A_NAME,		  "Name",	     AF_BUILTIN,		263)
DOATTR(A_FLAGS,		  "Flags",	     AF_BUILTIN,		264)
DOATTR(A_ZONE,		  "Zone",	     AF_BUILTIN|DBREF,		265)
DOATTR(A_NEXT,		  "Next",	     AF_BUILTIN|DBREF,		266)
DOATTR(A_MODIFIED,	  "Modified",	     AF_BUILTIN|DATE,		267)
DOATTR(A_CREATED,	  "Created",	     AF_BUILTIN|DATE,		268)
DOATTR(A_LONGFLAGS,       "Longflags",       AF_BUILTIN,                269)
DOATTR(A_CNAME,		  "CName",	     AF_BUILTIN,		270)
DOATTR(A_APASTE,	  "APaste",	     UNIMP,                     271)
DOATTR(A_APASTE_B,        "APaste_B",        UNIMP,                     272)
DOATTR(A_APASTE_E,        "APaste_E",        UNIMP,                     273)
DOATTR(A_LSEE,            "LSee",            INH|LOCK,                  274)

DOATTR(A_PREFIX,          "Prefix",          INH,                       300)
DOATTR(A_SUFFIX,          "Suffix",          INH,                       301)
DOATTR(A_CTITLE,          "CTitle",          INH,                       302)

/* this used to be MOTD but it was dumb to put the motd in the db and have 
   empty attrs on everyone.  So I reused the attrs. -wm */
DOATTR(A_IDLE_CUR,	  "Idle_cur",	     SDARK|NOMOD|UNIMP|WIZARD|NOMEM,1023)
DOATTR(A_IDLETIME,	  "Idletime",	     INH,			1015)
DOATTR(A_BANNED,	  "Banned",	     WIZARD,			1016)
DOATTR(A_TITLE,		  "Title",	     INH|WIZARD,		1017)
DOATTR(A_CAPTION,	  "Caption",	     INH,			1018)
DOATTR(A_EXPIRE,	  "Expire",	     WIZARD,			1019) 
DOATTR(A_PREVTIME,	  "PrevTime",	     WIZARD|SDARK|NOMEM|TIME,	1020) 
DOATTR(A_AGE,		  "Age",	     AF_BUILTIN|TIME|OSEE,	1021) 
DOATTR(A_LASTSITE,	  "Lastsite",	     SDARK|WIZARD|NOMOD|NOMEM,	1022) 

/* this is all combat stuff.*
 * dont use 1015 - 1024 -- someone decided it'd be fun to reserve this range
 * for random stuff  -wm
 */

DOATTR(A_RACE,            "Race",            WIZARD,                   1000)
DOATTR(A_LEVEL,           "Level",           WIZARD|INH,               1001)
DOATTR(A_HITPOINTS,       "HitPoints",       WIZARD,                   1002)
DOATTR(A_MAXHP,           "MaxHp",           WIZARD|INH,               1003)
DOATTR(A_STRENGTH,        "Strength",        WIZARD|INH|SDARK,         1004)
DOATTR(A_HITRATE,         "HitRate",         WIZARD|INH|SDARK,         1005)
DOATTR(A_MAGICPOINTS,     "MagicPoints",     WIZARD,                   1006)
DOATTR(A_MAXMP,           "MaxMp",           WIZARD|INH,               1007)
DOATTR(A_NEXTEXP,         "NextExp",         WIZARD,                   1008)
DOATTR(A_EXP,             "Exp",             WIZARD,                   1009)
DOATTR(A_NA,              "NA",              WIZARD|INH|SDARK,         1010)
DOATTR(A_GUILD,           "Guild",           WIZARD,                   1011)
DOATTR(A_DEXTERITY,       "Dexterity",       WIZARD|INH|SDARK,         1012)
DOATTR(A_EXPVALUE,        "ExpValue",        WIZARD|INH|SDARK,         1013)
DOATTR(A_BANK,            "Bank",            WIZARD|INH|SDARK,         1014)

DOATTR(A_WISDOM,          "Wisdom",          WIZARD|INH|SDARK,         1025)
DOATTR(A_LUCK,            "Luck",            WIZARD|INH|SDARK,         1026)
DOATTR(A_VIRTUE,          "Virtue",          WIZARD|INH|SDARK,         1027)
DOATTR(A_TYPE,            "Type",            WIZARD|INH|SDARK,         1028)
DOATTR(A_WEAPON,          "Weapon",          WIZARD|SDARK,             1029)
DOATTR(A_EQUIPPED,        "Equipped",        WIZARD|SDARK,             1030)
DOATTR(A_QUESTPOINTS,     "QuestPoints",     WIZARD|SDARK,             1031)
DOATTR(A_TALK,            "Talk",            INH,                      1032)
DOATTR(A_ATALK,           "ATalk",           INH,                      1033)
DOATTR(A_OTALK,           "OTalk",           INH,                      1034)
DOATTR(A_GOALS,           "Goals",           WIZARD|SDARK,             1035)
DOATTR(A_CHAPTER,         "Chapter",         WIZARD|SDARK,             1036)
DOATTR(A_DEATHS,          "Deaths",          WIZARD|SDARK,             1037)
DOATTR(A_MENULIST,        "MenuList",        WIZARD|SDARK,             1038)
DOATTR(A_GOLDVALUE,       "GoldValue",       WIZARD|INH|SDARK,         1039)
DOATTR(A_RAINBOW,         "Rainbow",         WIZARD|SDARK,             1040)
DOATTR(A_LASTCHANGE,      "LastChange",      WIZARD|SDARK,             1041)
DOATTR(A_AREA,            "Area",            WIZARD|INH|SDARK,         1042)
DOATTR(A_FIGHT,           "Fight",           INH,                      1043)
DOATTR(A_AFIGHT,          "AFight",          INH,                      1044)
DOATTR(A_OFIGHT,          "OFight",          INH,                      1045)
DOATTR(A_DEFEAT,          "Defeat",          INH,                      1046)
DOATTR(A_ADEFEAT,         "ADefeat",         INH,                      1047)
DOATTR(A_ODEFEAT,         "ODefeat",         INH,                      1048)
DOATTR(A_WHOIDLE,         "WhoIdle",         INH,                      1049)
DOATTR(A_DEATH,           "Death",           INH,                      1050)
DOATTR(A_ADEATH,          "ADeath",          INH,                      1051)
DOATTR(A_ODEATH,          "ODeath",          INH,                      1052)
DOATTR(A_SBAR,            "Sbar",            WIZARD|SDARK,             1053)
DOATTR(A_STRPRC,          "StrPrc",          WIZARD|SDARK,             1054)
DOATTR(A_DEXPRC,          "DexPrc",          WIZARD|SDARK,             1055)
DOATTR(A_INTPRC,          "IntPrc",          WIZARD|SDARK,             1056)
DOATTR(A_WISPRC,          "WisPrc",          WIZARD|SDARK,             1057)
DOATTR(A_LUCKPRC,         "LuckPrc",         WIZARD|SDARK,             1058)
DOATTR(A_STMPRC,          "StmPrc",          WIZARD|SDARK,             1059)
DOATTR(A_EXPRATE,         "ExpRate",         WIZARD|SDARK,             1060)
DOATTR(A_MATERIAL,        "Material",        WIZARD|SDARK,             1061)
DOATTR(A_WHOCOLOR,        "WhoColor",        WIZARD|SDARK,             1062)
DOATTR(A_WIMPY,           "Wimpy",           INH,                      1063)
DOATTR(A_OWIMPY,          "OWimpy",          INH,                      1064)
DOATTR(A_AWIMPY,          "AWimpy",          INH,                      1065)

DOATTR(A_DAMAGE,	  "Damage",	     WIZARD,                   1070)
DOATTR(A_BULK,		  "Bulk",	     WIZARD,                   1071)
DOATTR(A_MOVES,           "Moves",           WIZARD,                   1072)

DOATTR(A_EQLIST,          "EQLIST",          WIZARD|SDARK,             1103)
DOATTR(A_ALEVEL,          "ALevel",          INH,                      1105)
DOATTR(A_OLEVEL,          "OLevel",          INH,                      1106)
DOATTR(A_LST_ENMY_LVL,    "Last_Enemy_Lvl",  WIZARD|SDARK,             1107)
DOATTR(A_AUTOATTACK,      "AutoAttack",      WIZARD|SDARK|INH,         1108)
DOATTR(A_TOWN,            "Town",            WIZARD|SDARK,             1109)
DOATTR(A_LASTLOC,         "LastLoc",         NOMOD|SDARK,              1110)
DOATTR(A_SHIELD,          "Shield",          WIZARD|SDARK,             1115)
DOATTR(A_HEAD,            "Head",            WIZARD|SDARK,             1116)
DOATTR(A_HANDS,           "Hands",           WIZARD|SDARK,             1117)
DOATTR(A_ARMS,            "Arms",            WIZARD|SDARK,             1118)
DOATTR(A_ABDOMEN,         "Abdomen",         WIZARD|SDARK,             1119)
DOATTR(A_LEGS,            "Legs",            WIZARD|SDARK,             1120)
DOATTR(A_FEET,            "Feet",            WIZARD|SDARK,             1121)
DOATTR(A_INTELLIGENCE,    "Intelligence",    WIZARD|INH|SDARK,         1122)
DOATTR(A_STAMINA,         "Stamina",         WIZARD|INH|SDARK,         1124)
DOATTR(A_SKILLS,          "Skills",          WIZARD|INH|SDARK,         1125)

/*
DOATTR(A_HPMAX,		  "HPMax", 	     WIZARD,			1000)
DOATTR(A_HITPOINTS,	  "HP",		     WIZARD,		 	1001)
DOATTR(A_KILL,		  "Kill",	     INH,			1002)
DOATTR(A_OKILL,		  "OKill",	     INH,			1003)
DOATTR(A_VKILL,		  "VKill",	     INH,			1014)
DOATTR(A_AKILL,		  "AKill",	     INH,			1004)
DOATTR(A_HIT,		  "Hit",	     INH|WIZARD,		1005)
DOATTR(A_OHIT,		  "OHit",	     INH|WIZARD,		1006)
DOATTR(A_VHIT,		  "VHit",	     INH|WIZARD,		1007)
DOATTR(A_MISS,		  "Miss",	     INH|WIZARD,		1008)
DOATTR(A_OMISS,		  "OMiss",	     INH|WIZARD,		1009)
DOATTR(A_VMISS,		  "VMiss",	     INH|WIZARD,		1010)
DOATTR(A_CHIT,		  "CHit",	     INH|WIZARD,		1011)
DOATTR(A_CMISS,		  "CMiss",	     INH|WIZARD,		1012)
DOATTR(A_CVHIT,		  "CVHit",	     INH|WIZARD,		1013)
DOATTR(A_CVMISS,	  "CVMiss",	     INH|WIZARD,		1030)
DOATTR(A_COHIT,		  "COHit",	     INH|WIZARD,		1031)
DOATTR(A_COMISS,	  "COMiss",	     INH|WIZARD,		1032)

DOATTR(A_LEVEL, 	  "Level",	     WIZARD,			1050)
DOATTR(A_MENULIST,	  "Menulist",	     WIZARD,			1052)
DOATTR(A_MAXHP,		  "MaxHP", 	     WIZARD,			1054)
DOATTR(A_DEATHS,	  "Deaths",	     WIZARD,			1055)
DOATTR(A_MAGICPOINTS,	  "MP",		     WIZARD,			1056)
DOATTR(A_QUESTPOINTS,	  "QP",		     WIZARD, 			1057)
DOATTR(A_EXPVALUE,	  "Exp Value",	     WIZARD,			1058)
DOATTR(A_WISDOM,	  "Wisdom",	     WIZARD,			1059)
DOATTR(A_STAMINA,	  "Stamina",	     WIZARD,			1060)
DOATTR(A_VIRTUE,	  "Virtue",	     WIZARD,			1061)
DOATTR(A_DEXPRC,	  "DexPrc",	     WIZARD,			1062)
DOATTR(A_INTPRC,	  "IntPrc",	     WIZARD,			1063)
DOATTR(A_WISPRC,	  "WisPrc",	     WIZARD|SDARK|NOMOD,        1064)
DOATTR(A_GOALS,		  "Goals",	     WIZARD,			1065)  */
/* end combat stuff, I hope */


#undef OSEE
#undef SDARK
#undef WIZARD
#undef UNIMP
#undef NOMOD
#undef DATE
#undef INH
#undef LOCK
#undef FUNC
#undef DBREF
#undef NOMEM
#undef TIME
